// components/floatNav/floatNav.js
Component({
  /**
   * 组件的属性列表
   */
  properties: {

  },

  /**
   * 组件的初始数据
   */
  data: {
    isPopping: false,//是否已经弹出
    navBars: [
      { path: '', icon: 'https://bigaka-xie.oss-cn-shanghai.aliyuncs.com/home.png', animationObj: {}, type: '', title: '主页' },
      { path: '', icon: 'https://bigaka-xie.oss-cn-shanghai.aliyuncs.com/category.png', animationObj: {}, type: '', title: '分类' },
      { path: '', icon: 'https://bigaka-xie.oss-cn-shanghai.aliyuncs.com/order.png', animationObj: {}, type: '', title: '我的订单' },
      { path: '', icon: 'https://bigaka-xie.oss-cn-shanghai.aliyuncs.com/my.png', animationObj: {}, type: '', title: '我的' },
      { path: '', icon: 'https://bigaka-xie.oss-cn-shanghai.aliyuncs.com/cart.png', animationObj: {}, type: '', title: '购物车' },
    ],
    animMenu: {},
  },

  attached(){
    console.log('attached')
  },

  /**
   * 组件的方法列表
   */
  methods: {
    //点击弹出
    bindShowOrCloseMenu: function () {
      if (this.data.isPopping) {
        //缩回动画
        this.closeAnimation();
        this.setData({
          isPopping: false
        })
      } else if (!this.data.isPopping) {
        //弹出动画
        this.popAnimation();
        this.setData({
          isPopping: true
        })
      }
    },
    //点击menu
    bindNav(e) {
      console.log(e)
    },
    //弹出nav动画
    popAnimation() {
      let len = this.data.navBars.length;
      this.data.navBars.forEach((item, index) => {
        let animationContext = wx.createAnimation({
          duration: 500,
          timingFunction: 'ease-out'
        });

        this.handlerAnimation(len, index, animationContext);

        item.animationObj = animationContext.export();
      });

      //plus顺时针旋转
      var animationMenu = wx.createAnimation({
        duration: 500,
        timingFunction: 'ease-out'
      })

      animationMenu.rotateZ(360).step();

      this.setData({
        animMenu: animationMenu.export(),
        navBars: this.data.navBars
      });
    },
    //关闭nav动画
    closeAnimation() {
      //plus顺时针旋转
      var animationMenu = wx.createAnimation({
        duration: 500,
        timingFunction: 'ease-out'
      })

      this.data.navBars.forEach((item, index) => {
        let animationContext = wx.createAnimation({
          duration: 500,
          timingFunction: 'ease-out'
        });

        animationContext.translate(0, 0).rotateZ(0).opacity(0).step();
        item.animationObj = animationContext.export();
      });

      animationMenu.rotateZ(0).step();
      this.setData({
        animMenu: animationMenu.export(),
        navBars: this.data.navBars
      });
    },
    //处理动画逻辑分4个和5个时
    handlerAnimation(len, index, animationContext) {
      const translateFour = [[-50, -80], [-80, -30], [-80, 30], [-50, 80]];
      const translateFive = [[-50, -100], [-90, -55], [-110, 0], [-90, 55], [-50, 100]];
      if (len == 4) {
        animationContext.translate(translateFour[index][0], translateFour[index][1]).rotateZ(360).opacity(1).step();
      }
      else if (len == 5) {
        animationContext.translate(translateFive[index][0], translateFive[index][1]).rotateZ(360).opacity(1).step();
      }
    },
  }
})
